/*   FILE NAME : EXAMP1.C                                             */
/*   Program Example : INTERACTIVE DATA TRANSFER                      */
/*                                                                    */
/*   Purpose : This program outputs data strings entered by user      */
/*           and enters data string from the GP-IB.                   */
/*                                                                    */
/*                                                                    */
/*   Language : C86                                                   */
/*                                                                    */
#include <stdio.h>
#include <string.h>

int ioerr;

main()
{
  char s;
  ieseg(0xC000);
  ieabort();
start:  crt_cls();

  printf("****** Demo Program for GP-IB interface ****** \n");
  printf("\n\n\n 1 : OUTPUT DATA");
  printf("\n\n\n 2 : ENTER DATA");
  printf("\n\n\n 3 : EXIT");
  printf("\n\n\n Select a function : ");
  s=0;
  while(s>51 || s<49)s=key_getc();
  printf("%c",s);
  switch(s)
  {
   case '1': output();
             break;
   case '2': enter();
             break;
   case '3': exit(0);
   default : printf("SOMETHING WRONG !");
  }
  goto start;
}

output()
{
int addr,length;
char outstr[100];
char s;
do
 {
  printf("\n\n\n OUTPUT DATA :\n");
  printf("\n To which address ? ");
  scanf("%d",&addr);
  printf("\n Output string ? ");
  scanf("%s",outstr);
  length=strlen(outstr);
  ioerr=ieoutput(addr,outstr,length);
  iochk();
  printf("\n Output data again ?(y/n)");
  s=key_getc();
 }while(s=='y');
}

enter()
{
int addr,length;
char instr[100];
char s;

do
 {
  printf("\n\n\n ENTER DATA :\n");
  printf("\n From which address ? ");
  scanf("%d",&addr);
  printf("\n Entered string : ");
  ioerr=ieenter(addr,instr,100);
  iochk();
  printf("%s\n",instr);
  printf("\n Enter data again ?(y/n)");
  s=key_getc();
 }while(s=='y');
}

iochk()
{
 switch(ioerr)
 {
  case 0 : printf("\n Data transfered!\n\n");
           break;
  case 1 : printf("\n Handshake timeout ! \n\n");
           break;
  default : printf("\n Interface Error ! \n\n");
           break;
 }
}
