/*   FILE NAME : EXAMP2.C                                        */
/*   Program Example : SET IEEE-488 PRINTER                      */
/*                                                               */
/*   Purpose : This program converts a IEEE-488 printer to a     */
/*            PC system printer.                                 */
/*                                                               */
/*                                                               */
/*   Language : C86                                              */
/*                                                               */

main()
{
  int addr,portn;
  char yn;
  char *ptr;
  char outstr[100];
  ieseg(0xC000);

  /*   Enter the GP-IB printer address   */
  do
  {
    addr=-1;

    while(addr<0 || addr>30)
    {
      printf("\n\nEnter the GP-IB printer address ? ");
      scanf("%d",&addr);
    }

    /*   Enter the output port             */
    portn=-1;
    while(portn!=1 && portn!=2)
    {
      printf("\n\nEnter the printer port ? (1/LPT1:  2/LPT2:) ");
      scanf("%d",&portn);
    }

    iedevice(addr,portn);
    printf("\nGP-IB printer is ready to use.");
    printf("\n\nSend string to printer ? (y/n)");
    scanf("%s",&yn);
    printf("\n");
    if(yn != 'y')exit(0);
    printf("\nEnter the string : ");
    scanf("%s",&outstr[0]);
    printf("\nSending : %s",outstr);
    ptr=fopen("PRN:","w");
    fprintf(ptr,"%s",outstr);
    fclose(ptr);
  }while(1==1);
}
