'**************************************************************************
'FILE NAME:   PC1ACOM.BAS
'             an include file that contains all the common variables shared
'             between the main module and sub program module
'
'DATE:        8/9/89
'
'AUTHOR:      KATHY K. F. PU
'**************************************************************************

COMMON SHARED TALKS AS STRING * 17    'string to hold the set talker addr command
COMMON SHARED LISTENS AS STRING * 19  'string to hold the set listener addr command
COMMON SHARED UNTS AS STRING * 3      'string to hold UNT
COMMON SHARED UNLS AS STRING * 3      'string to hold UNL
COMMON SHARED SEC0DATAS AS STRING * 11'string that holds "SEC 0 DATA "
COMMON SHARED SEC0S AS STRING * 6     'string that holds "SEC 0 "
COMMON SHARED CMDSTRS AS STRING * 100 'command string
COMMON SHARED DATAS AS STRING * 100   'data string
COMMON SHARED DEVS AS STRING * 3      'device address ascii string
COMMON SHARED CONFIGS AS STRING * 100 'configuration string
COMMON SHARED OUTPUTS AS STRING * 100 'string that holds data be output to bus
COMMON SHARED IOERR, LENGTH           '
COMMON SHARED SPACE100S AS STRING * 100
COMMON SHARED SPACE80S  AS STRING * 80

'***********************************************************************
'*     following are variables that holds the offset of IEEE routine
'***********************************************************************
COMMON SHARED INIT%, ABORT%, DEVCLOR%, ENTER%, EOL%, ERRPTR%
COMMON SHARED IOOUTPUT%, PPOLL%, PPOLLC%, SEND%, SPOLL%, STATUS%, TIMEOUT%
COMMON SHARED ISRDONE%                'flag that indicates interrupt be serviced
COMMON SHARED INTCOUNT%               'count for number of interrupt serviced
COMMON SHARED SR%                     'serial poll response
COMMON SHARED SMR%                    'serial message received, LSB of SR%
COMMON SHARED ADDR%                   'PC1A address


DECLARE SUB CHGVECTOR (IRQ%)          'in INT488.OBJ to change int vector
DECLARE SUB RESTOREVECTOR (IRQ%)      'in INT488.OBJ to restore int vector

DECLARE SUB SETPTALKADD (DEV%)        'in PC1ALIB.BAS set primary talker add
DECLARE SUB SETUP4834 (CONFIG$, DEV%) 'in PC1ALIB.BAS output config. command
DECLARE SUB READ4834SETUP (DEV%)      'in PC1ALIB.BAS read 4834 configuration
DECLARE SUB IOCHK (IOERR)             'in PC1ALIB.BAS that checks io error
DECLARE SUB TDELAY (N%)               'in PC1ALIB.BAS that sets the delay
DEFINT A-Z
CONST LF = 10, CR = 13, YKEY = 89, NKEY = 78
CONST ESCKEY = 27, RTNKEY = 13

OUTEOL$ = CHR$(13) + CHR$(10)         'set output string terminator
'**********************************************************************
'  initialize the offset address for IEEE routines
'**********************************************************************
ABORT% = 9: DEVCLR% = 15: ENTER% = 6: EOL% = 12: ERRPTR% = 60: INIT% = 0
IOOUTPUT% = 3: PPOLL% = 24: PPOLLC% = 27: SEND% = 36: SPOLL% = 39:
STATUS% = 42: TIMEOUT% = 45

MYADDR% = 21: IOPORT% = &H2B8

'**********************************************************************
'  initialize string variables
'**********************************************************************
TALKS = "UNL UNT MLA TALK "
LISTENS = "UNL UNT MTA LISTEN "
UNTS = "UNT"
UNLS = "UNL"
SEC0DATAS = "SEC 0 DATA "
SEC0S = "SEC 0 "
SPACE100S = STRING$(100, " ")
SPACE80S = STRING$(80, " ")


