

'**** QBASIC V3 Program demo using an ICS 488-PC1A and a 4833 Parallel Interface ***
'3/3/89 * revised program
DEFINT A
CLS : COLOR 15, 0
                ' set 444-PC1A card address
init% = 0: dataout% = 3: enter% = 6: abort% = 9: eol% = 12: spoll% = 39
send% = 36: timeout% = 45: errptr% = 60
ics% = 4                     ' set 4833 address
addrff% = -1                 ' set secondary address
cmd$ = SPACE$(30)            ' define command buffe
rd$ = SPACE$(255)            ' define input buffer
wrt$ = SPACE$(255)
rc$ = SPACE$(255)            'define configuration buffer
sp$ = SPACE$(30)
longsp$ = SPACE$(255)

DEF SEG = &HD000
CALL absolute(&H2B8, 21, &H100, 0)

CALL absolute(abort%)
t% = 10: CALL absolute(t%, timeout%)
main: COLOR 15, 0                '********** main program **********
LOCATE 4, 10: PRINT "488PC1A / ICS 4833 Demo Program"
COLOR 11, 0: LOCATE 6, 10: PRINT "Enter '1' to Display the Configuration"
LOCATE 7, 10: PRINT "Enter '2' to Change the Configuration"
LOCATE 8, 10: PRINT "Enter '3' to Output Data"
LOCATE 9, 10: PRINT "Enter '4' to Input Data"
LOCATE 10, 10: PRINT "Enter '5' to Serial Poll"
LOCATE 12, 10: PRINT "Enter '9' to exit to QBASIC"
LOCATE 14, 10: PRINT "Enter choice:": LOCATE 14, 23: PRINT sp$: COLOR 15, 7
LOCATE 14, 24: INPUT a: COLOR 11, 0
'*************
ON a GOTO 500, 600, 200, 300, 400, 100, 100, 100, 800
100 : LOCATE 14, 28: COLOR 4, 0: PRINT "INVALID CHOICE!": COLOR 2, 0: BEEP: GOTO main
'*************
200 : 'cls                           '*** OUTPUT DATA ***
      LOCATE 15, 10: PRINT longsp$
      LOCATE 16, 10: PRINT longsp$: LOCATE 17, 10: PRINT longsp$
      LOCATE 14, 10: INPUT "Enter data to output:", wrt$
      LOCATE 17, 10: PRINT longsp$
      LOCATE 16, 10: PRINT longsp$
      LOCATE 16, 10: PRINT "Output data: "; wrt$
      CALL absolute(ics%, wrt$, dataout%)
      GOTO main
300 : CLS                           '*** INPUT DATA ***
      LOCATE 16, 10: PRINT longsp$: LOCATE 17, 10: PRINT longsp$
      CALL absolute(ics%, s%, spoll%)       'only input data if 'data avail' flag on
      IF s% = 1 OR s% = 5 OR s% = 65 OR s% = 69 THEN GOTO 350
      IF INSTR(rc$, "TH0") <> 0 THEN GOTO 350 ELSE GOTO 390
350 : cmd$ = "UNL UNT MLA TALK 4 "
      CALL absolute(cmd$, send%)
      CALL absolute(addrff%, rd$, enter%)
      LOCATE 16, 10: PRINT longsp$: LOCATE 17, 10: PRINT longsp$
      LOCATE 18, 10: PRINT longsp$: LOCATE 19, 10: PRINT longsp$
      LOCATE 16, 10: PRINT "Input data from 4833: "; rd$
      GOTO main
390 : LOCATE 16, 10: PRINT longsp$
      LOCATE 17, 10: PRINT longsp$
      LOCATE 16, 10: PRINT "No Input Data available! "
      GOTO main
400 : CLS                           '*** SERIAL POLL ***
      LOCATE 16, 10: PRINT longsp$
      LOCATE 17, 10: PRINT longsp$
      CALL absolute(ics%, s%, spoll%)
      LOCATE 16, 10: PRINT "Serial Poll Response: "; s%
      GOTO main
500 : CLS                           '*** PRESENT CONFIGURATION ***
      cmd$ = "UNL UNT MLA TALK 4 SEC 0 ": CALL absolute(cmd$, send%)
      CALL absolute(addrff%, rc$, enter%)
      LOCATE 16, 10: PRINT "Present configuration: "
      LOCATE 18, 10: PRINT rc$
      GOTO main
600 : CLS                           '*** CHANGE CONFIGURATION ***
      LOCATE 16, 10: PRINT longsp$
      LOCATE 17, 10: PRINT longsp$
      cmd$ = "UNL UNT MLA TALK 4 SEC 0 ": CALL absolute(cmd$, send%)
      CALL absolute(addrff%, rd$, enter%)
      LOCATE 14, 10: PRINT "Present configuration: "
      LOCATE 15, 10: PRINT rd$
      LOCATE 18, 10: INPUT "Enter new configuration value: "; wrt$
      IF wrt$ = "" THEN GOTO 650
      cmd$ = "UNL UNT MTA LISTEN 4 SEC 0 ": CALL absolute(cmd$, send%)
      CALL absolute(addrff%, wrt$, dataout%)
      cmd$ = "UNL UNT MLA TALK 4 SEC 0 ": CALL absolute(cmd$, send%)
      CALL absolute(addrff%, rc$, enter%)
      CLS : LOCATE 16, 10: PRINT "New configuration: "
      LOCATE 18, 10: PRINT rc$: GOTO main
650 : CLS : GOTO main
800 : END










