

'**** QBASIC V3/V4.5 demo using an ICS 488-PC1A and a HP 3478A MULTIMETER ***
'***** 6-16-89 * TOM CURFMAN
DEFINT A
CLS : COLOR 15, 0
'***** SET 488-PC1A CARD FUNCTION NAMES AND VARIABLES
init% = 0: dataout% = 3: enter% = 6: abort% = 9: eol% = 12: spoll% = 39
send% = 36: timeout% = 45: errptr% = 60: llout% = 18: remote% = 33
devclr% = 15: trigger% = 48
ics% = 2                     ' set 3478A address
addrff% = -1                 ' set secondary address
cmd$ = SPACE$(30)            ' define command buffer
rd$ = SPACE$(30)             ' define input buffer
wrt$ = SPACE$(255)
rc$ = SPACE$(255)            'define configuration buffer
				       
sp$ = SPACE$(30)
longsp$ = SPACE$(255)
DEF SEG = &HD000
CALL absolute(&H2B8, 21, &H100, 0)

' define output buffer
CALL absolute(abort%)                'send an IFC to the bus
t% = 10: CALL absolute(t%, timeout%) 'set bus timeout to 10 milliseconds
main: COLOR 15, 0             '********** main program **********
LOCATE 2, 10: PRINT "ICS 488PC1A / HP3478A MULTIMETER Demo Program"
COLOR 11, 0: LOCATE 5, 10: PRINT "Enter '1' to Output Data"
LOCATE 6, 10: PRINT "Enter '2' to Input Data"
LOCATE 7, 10: PRINT "Enter '3' to Serial Poll"
LOCATE 8, 10: PRINT "Enter '4' to send REMOTE & LOCAL LOCK OUT cmds"
LOCATE 9, 10: PRINT "Enter '5' to TRIGGER the MULTIMETER"
LOCATE 10, 10: PRINT "Enter '8' to CLEAR the MULTIMETER"
LOCATE 12, 10: PRINT "Enter '9' to exit to QBASIC"
LOCATE 14, 10: PRINT "Enter choice:": LOCATE 14, 23: PRINT sp$: COLOR 15, 7
LOCATE 14, 24: INPUT a: COLOR 11, 0
'*************
ON a GOTO 200, 300, 450, 400, 700, 100, 500, 800, 900
100 : LOCATE 14, 28: COLOR 4, 0: PRINT "INVALID CHOICE!": COLOR 2, 0: BEEP: GOTO main
'*************
200 : CLS                           '*** OUTPUT DATA ***
      LOCATE 15, 10: PRINT longsp$
      LOCATE 16, 10: PRINT longsp$: LOCATE 17, 10: PRINT longsp$
      LOCATE 14, 10: INPUT "Enter data to output:", wrt$
      LOCATE 17, 10: PRINT longsp$
      LOCATE 16, 10: PRINT longsp$
      CALL absolute(ics%, wrt$, dataout%)
      LOCATE 16, 10: PRINT "Output data: "; wrt$
      GOTO 500
300 : CLS                           '*** INPUT DATA ***
      LOCATE 16, 10: PRINT longsp$: LOCATE 17, 10: PRINT longsp$
      CALL absolute(ics%, s%, spoll%)       'only input data if 'data avail' flag on
      IF s% = 1 OR s% = 3 OR s% = 65 OR s% = 66 OR s% = 67 THEN GOTO 350 ELSE GOTO 390
350 :     
      LOCATE 16, 10: PRINT longsp$: LOCATE 17, 10: PRINT longsp$
      LOCATE 18, 10: PRINT longsp$: LOCATE 19, 10: PRINT longsp$
      CALL absolute(ics%, rd$, enter%)
      LOCATE 16, 10: PRINT "Input data from 3478A: "; rd$
      GOTO 500
390 : LOCATE 16, 10: PRINT longsp$
      LOCATE 17, 10: PRINT longsp$
      LOCATE 16, 10: PRINT "No Input Data available! "
      GOTO 500
400 : CLS                           '*** LOCAL LOCK OUT ***
      LOCATE 16, 10: PRINT longsp$
      LOCATE 17, 10: PRINT longsp$
      CALL absolute(ics%, remote%)
      CALL absolute(llout%)
      LOCATE 16, 10: PRINT "LOCAL LOCK OUT SENT!"
      GOTO 500
450 : CLS                           '*** SERIAL POLL ***
      LOCATE 16, 10: PRINT longsp$
      LOCATE 17, 10: PRINT longsp$
      CALL absolute(ics%, s%, spoll%)
      LOCATE 16, 10: PRINT "Serial Poll Response: "; s%
      GOTO 500
500 :                               '*** UNLISTEN/UNTALK MULTIMETER ***
      cmd$ = "UNL UNT ": CALL absolute(cmd$, send%)
      GOTO main
600 :
650 : CLS : GOTO main
700 : CLS                           '*** TRIGGER MULTIMETER ***
      LOCATE 16, 10: PRINT longsp$
      LOCATE 17, 10: PRINT longsp$
      CALL absolute(ics%, trigger%)
      LOCATE 16, 10: PRINT "MULTIMETER TRIGGERED!"
      GOTO 500
800 : CLS                           '*** CLEAR MULTIMETER ***
      LOCATE 16, 10: PRINT longsp$
      LOCATE 17, 10: PRINT longsp$
      CALL absolute(ics%, devclr%)
      LOCATE 16, 10: PRINT "3478A CLEARED!"
      GOTO 500

900 : END









