{


  CHAPTER  5    PROGRAMMING TECHNIQUES
  ____________________________________

}
{
5-1 Interactive Data Transfer
}
{ FILE NAME : EX1_TB.PAS                                            }
{             INTERACTIVE DATA TRANSFER                             }
{ Purpose   : This program outputs data strings entered by users    }
{             and enters data string from the IEEE-488 bus.         }
{ Language  : Turbo Pascal                                          }

program example1(input,output);

{$I TBPGPIB.INC}

procedure iochk;
  var
    errno:integer absolute $C000:$201A;

  begin
    writeln;
    case errno of
      0 : writeln(' Data transferred!');
      1 : writeln(' Handshake timeout ! ');
      else
          writeln(' Interface Error ! ');
    end;
    writeln;
  end;

procedure outputdata;
  var
    addr,length : integer;
    outstr      : lstring;
    s           : char;

  begin
    repeat
      writeln;
      writeln(' OUTPUT DATA :');
      write(' To which address ? ');
      read(addr); writeln;
      write(' Output string ? ');
      read(outstr); writeln;
      writeln(' Outputing data ...');
      ieoutput(addr,outstr);
      iochk;
      write(' Output data again ?(y/n)  ');
      read(s); writeln;
    until s='n';
  end;

procedure enterdata;
  var
    addr,length : integer;
    instr       : lstring;
    s           : char;

  begin
    repeat
      writeln(' ENTER DATA :');
      write(' From which address ? ');
      read(addr); writeln;
      writeln(' Entering string ... ');
      instr:='                                                       ';
      ieenter(addr,instr);
      iochk;
      writeln(' Entered string : ',instr);
      write(' Enter data again ?(y/n)  ');
      read(s); writeln;
    until s='n';
  end;

var
  sel : integer;

begin
  repeat
    ieabort;
    clrscr;

    writeln('*** Demo Program for GP-IB Interface *** ');
    writeln;
    writeln(' 1 : OUTPUT DATA');
    writeln;
    writeln(' 2 : ENTER DATA');
    writeln;
    writeln(' 3 : EXIT');
    writeln;
    write(' Select a function : ');
    read(sel); writeln;
    if (sel<4) and (sel>0) then
      begin
        case sel of
          1 : outputdata;
          2 : enterdata;
          3 : ;
          else
              writeln('********** SOMETHING WRONG ! ************');
        end;
      end;
  until sel=3;
end.

{     END OF PROGRAM   }
