   { Start of definition of IEEE-488 procedures }
   const seg_addr=$C0;                              {set card address}
   Type lstring = string[255];
   Procedure ieinit(ioport,myaddr,setting:integer);
     begin inline  ($9A/$00/$04/$00/seg_addr); end; { call seg_addr:0400 }
   Procedure ieoutput(addr:integer;var tmp:lstring);
     begin inline  ($9A/$03/$04/$00/seg_addr); end; { call C000:0403 }
   Procedure ieenter(addr:integer;var instr:lstring);
     begin inline  ($9A/$06/$04/$00/seg_addr); end; { call C000:0406 }
   Procedure ieabort;
     begin inline  ($9A/$09/$04/$00/seg_addr); end; { call C000:0409 }
   Procedure ieeol(addr,outeol:integer;var outeolstr:lstring;
                   ineol,ineolb:integer);
     begin inline  ($9A/$0C/$04/$00/seg_addr); end; { call C000:040C }
   Procedure iedevclr(addr:integer);
     begin inline  ($9A/$0F/$04/$00/seg_addr); end; { call C000:040F }
   Procedure iello;
     begin inline  ($9A/$12/$04/$00/seg_addr); end; { call C000:0412 }
   Procedure ielocal(addr:integer );
     begin inline  ($9A/$15/$04/$00/seg_addr); end; { call C000:0415 }
   Procedure ieppoll(var response:integer);
     begin inline  ($9A/$18/$04/$00/seg_addr); end; { call C000:0418 }
   Procedure ieppollc(addr,config:integer);
     begin inline  ($9A/$1B/$04/$00/seg_addr); end; { call C000:041B }
   Procedure ieppollu(addr:integer);
     begin inline  ($9A/$1E/$04/$00/seg_addr); end; { call C000:041E }
   Procedure ieremote(addr:integer);
     begin inline  ($9A/$21/$04/$00/seg_addr); end; { call C000:0421 }
   Procedure iesend(var cmdstr:lstring);
     begin inline  ($9A/$24/$04/$00/seg_addr); end; { call C000:0424 }
   Procedure iespoll(addr:integer;var response:integer);
     begin inline  ($9A/$27/$04/$00/seg_addr); end; { call C000:0427 }
   Procedure iestatus(condition:integer;var status:integer);
     begin inline  ($9A/$2A/$04/$00/seg_addr); end; { call C000:042A }
   Procedure ietimout(timeset:integer);
     begin inline  ($9A/$2D/$04/$00/seg_addr); end; { call C000:042D }
   Procedure ietrig(addr:integer);
     begin inline  ($9A/$30/$04/$00/seg_addr); end; { call C000:0430 }
   Procedure ieentera(addr,dataseg,datalen:integer);
     begin inline  ($9A/$33/$04/$00/seg_addr); end; { call C000:0433 }
   Procedure ieouta(addr,dataseg,datalen:integer);
     begin inline  ($9A/$36/$04/$00/seg_addr); end; { call C000:0436 }
   Procedure iedevice(addr,portno:integer);
     begin inline  ($9A/$39/$04/$00/seg_addr); end; { call C000:0439 }
   { End of definition of IEEE-488 procedures}
