'***********************************************************************
' FILE NAME :   PC1ALIB.BAS
'               a library file that contains all the sub program used
'               in QB1A34.BAS, QB1AINT.BAS, AND 1B1ADEV.BAS
'
' DATE:         8/9/89
'
' AUTHOR:       KATHY K.F. PU
'************************************************************************

' $INCLUDE: 'C:\QB45\PC1ACOM.BAS'

DEFSNG A-Z
SUB IOCHK (IOERR)
        SELECT CASE IOERR
        CASE 1
               PRINT
               PRINT "TIME OUT !!"
        CASE 2
               PRINT
               PRINT "INTERFACE ERROR!!"
        END SELECT
END SUB

SUB QB45ISR
     ISRDONE% = 1                      'set up isrdone flag
     INTCOUNT% = INTCOUNT% + 1         'increment interrupt count
     DATAS = SPACE100S                 'blank data string
     CALL ABSOLUTE(ADDR%, SR%, SPOLL%) 'do a serial poll
     SMR% = SR% MOD 2                  'test serial message received bit
     IF SMR% = 1 THEN                  'if smr set
         SETPTALKADD (ADDR%)           'send command to IEEE bus to set talker
         CALL ABSOLUTE(-1, DATAS, ENTER%)'and do an data enter
     END IF
     OUT &H20, &H20                    ' EOI for 8259 to enable int <=cur. int
     BYTE% = INP(IOPORT% + 2)          ' read in 7210 status reg to clear irq
END SUB

SUB READ4834SETUP (DEV%)      'sub program to read 4834 configuration and print
          CMDSTRS = SPACE100S 'blank the command string
          DEVS = "   "        'blank the string
          DEVS = STR$(DEV%)   'get the ascii code of 4834's address
          CMDSTRS = TALKS + DEVS + SEC0S 'build command string that set
          CALL ABSOLUTE(CMDSTRS, SEND%)  'the 4834's 2nd address as talker add
          CALL ABSOLUTE(-1, DATAS, ENTER%) 'enter configuration data from 4834
          PRINT DATAS                      'and print it
END SUB

SUB SETPTALKADD (DEV%)        'send command to set primary talker on bus
        CMDSTRS = SPACE100S   'blank the command string
        DEVS = "   "          'blank the device address ascii string
        DEVS = STR$(DEV%)     'store ascii code  device address
        CMDSTRS = TALKS + DEVS 'set up the command string
        CALL ABSOLUTE(CMDSTRS, SEND%)   'send the command string
END SUB

SUB SETUP4834 (CONFIG$, DEV%)    'send configuration command to 4834
        CMDSTRS = SPACE100S      'blank the command string
        DEVS = "   "             'blank the device address ascii string
        DEVS = STR$(DEV%)        'store the ascii code of 4834's bus address
        CMDSTRS = LISTENS + DEVS + SEC0DATAS 'set up command to make 4834
        CALL ABSOLUTE(CMDSTRS, SEND%)        '2nd address as a listener,send
        CALL ABSOLUTE(-1, CONFIG$, IOOUTPUT%)'output the configuration data
        CALL ABSOLUTE(UNLS, SEND%)           'output UNL command
END SUB

SUB TDELAY (N%)
     J% = 10 * N%
     FOR I% = 1 TO J%
         J% = J% + 1 - 1
     NEXT I%
END SUB

